import require$$0, { forwardRef, useRef, useEffect } from "react";
import { ValueSelector } from "react-querybuilder";
var jsxRuntime = { exports: {} };
var reactJsxRuntime_production_min = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var f = require$$0, k = Symbol.for("react.element"), l = Symbol.for("react.fragment"), m = Object.prototype.hasOwnProperty, n = f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, p = { key: true, ref: true, __self: true, __source: true };
function q(c, a, g) {
  var b, d = {}, e = null, h = null;
  g !== void 0 && (e = "" + g);
  a.key !== void 0 && (e = "" + a.key);
  a.ref !== void 0 && (h = a.ref);
  for (b in a)
    m.call(a, b) && !p.hasOwnProperty(b) && (d[b] = a[b]);
  if (c && c.defaultProps)
    for (b in a = c.defaultProps, a)
      d[b] === void 0 && (d[b] = a[b]);
  return { $$typeof: k, type: c, key: e, ref: h, props: d, _owner: n.current };
}
reactJsxRuntime_production_min.Fragment = l;
reactJsxRuntime_production_min.jsx = q;
reactJsxRuntime_production_min.jsxs = q;
{
  jsxRuntime.exports = reactJsxRuntime_production_min;
}
const jsx = jsxRuntime.exports.jsx;
const jsxs = jsxRuntime.exports.jsxs;
const BootstrapDragHandle = forwardRef(({
  className,
  title
}, dragRef) => /* @__PURE__ */ jsx("span", {
  ref: dragRef,
  className,
  title,
  children: /* @__PURE__ */ jsx("i", {
    className: "bi bi-grip-vertical"
  })
}));
BootstrapDragHandle.displayName = "BootstrapDragHandle";
const BootstrapNotToggle = ({
  className,
  handleOnChange,
  title,
  label,
  checked,
  disabled
}) => {
  const id = useRef(`notToggle-${Math.random()}`);
  return /* @__PURE__ */ jsxs("div", {
    className: `form-check-inline form-switch ${className}`,
    children: [/* @__PURE__ */ jsx("input", {
      id: id.current,
      className: "form-check-input",
      type: "checkbox",
      onChange: (e) => handleOnChange(e.target.checked),
      checked: !!checked,
      disabled
    }), /* @__PURE__ */ jsx("label", {
      title,
      htmlFor: id.current,
      className: "form-check-label",
      children: label
    })]
  });
};
BootstrapNotToggle.displayName = "BootstrapNotToggle";
const BootstrapValueEditor = ({
  fieldData,
  operator,
  value,
  handleOnChange,
  title,
  className,
  type,
  inputType,
  values,
  disabled,
  ...props
}) => {
  var _a;
  useEffect(() => {
    if (inputType === "number" && !["between", "notBetween", "in", "notIn"].includes(operator) && typeof value === "string" && value.includes(",")) {
      handleOnChange("");
    }
  }, [inputType, operator, value, handleOnChange]);
  if (operator === "null" || operator === "notNull") {
    return null;
  }
  const placeHolderText = (_a = fieldData == null ? void 0 : fieldData.placeholder) != null ? _a : "";
  const inputTypeCoerced = ["between", "notBetween", "in", "notIn"].includes(operator) ? "text" : inputType || "text";
  switch (type) {
    case "select":
    case "multiselect":
      return /* @__PURE__ */ jsx(ValueSelector, {
        ...props,
        className: `${className} form-select form-select-sm`,
        title,
        handleOnChange,
        value,
        disabled,
        multiple: type === "multiselect",
        options: values
      });
    case "textarea":
      return /* @__PURE__ */ jsx("textarea", {
        value,
        title,
        className,
        disabled,
        placeholder: placeHolderText,
        onChange: (e) => handleOnChange(e.target.value)
      });
    case "switch":
      return /* @__PURE__ */ jsx("span", {
        className: `custom-control custom-switch ${className}`,
        children: /* @__PURE__ */ jsx("input", {
          type: "checkbox",
          className: `form-check-input custom-control-input`,
          title,
          disabled,
          onChange: (e) => handleOnChange(e.target.checked),
          checked: !!value
        })
      });
    case "checkbox":
      return /* @__PURE__ */ jsx("input", {
        type: "checkbox",
        className: `form-check-input ${className}`,
        title,
        disabled,
        onChange: (e) => handleOnChange(e.target.checked),
        checked: !!value
      });
    case "radio":
      return /* @__PURE__ */ jsx("span", {
        title,
        children: values.map((v) => /* @__PURE__ */ jsxs("div", {
          className: "form-check form-check-inline",
          children: [/* @__PURE__ */ jsx("input", {
            className: "form-check-input",
            type: "radio",
            id: v.name,
            value: v.name,
            checked: value === v.name,
            disabled,
            onChange: (e) => handleOnChange(e.target.value)
          }), /* @__PURE__ */ jsx("label", {
            className: "form-check-label",
            htmlFor: v.name,
            children: v.label
          })]
        }, v.name))
      });
  }
  return /* @__PURE__ */ jsx("input", {
    type: inputTypeCoerced,
    value,
    title,
    className,
    disabled,
    placeholder: placeHolderText,
    onChange: (e) => handleOnChange(e.target.value)
  });
};
BootstrapValueEditor.displayName = "BootstrapValueEditor";
const bootstrapControlElements = {
  dragHandle: BootstrapDragHandle,
  notToggle: BootstrapNotToggle,
  valueEditor: BootstrapValueEditor
};
const bootstrapControlClassnames = {
  addGroup: "btn btn-secondary btn-sm",
  addRule: "btn btn-primary btn-sm",
  cloneGroup: "btn btn-secondary btn-sm",
  cloneRule: "btn btn-secondary btn-sm",
  lockGroup: "btn btn-secondary btn-sm",
  lockRule: "btn btn-secondary btn-sm",
  removeGroup: "btn btn-danger btn-sm",
  removeRule: "btn btn-danger btn-sm",
  combinators: "form-select form-select-sm",
  fields: "form-select form-select-sm",
  operators: "form-select form-select-sm",
  value: "form-control form-control-sm",
  valueSource: "form-select form-select-sm"
};
export { BootstrapDragHandle, BootstrapNotToggle, BootstrapValueEditor, bootstrapControlClassnames, bootstrapControlElements };
//# sourceMappingURL=index.es.js.map
